"""
    GraphView.py
    View derived class for 1d plotting


    Contact: Alexandre Gobbo (gobbo@esrf.fr)
    Version: 1.0
"""
import qt
import sys
try:
    from mdi import *
except:
    ###FIXME
    sys.path.insert(0,'../Depends')
    sys.path.insert(0,'../Src/')
    
    from mdi import *

from GraphView import *

def cmd():
    global arr1,view
    Numeric.multiply(arr1,2,arr1)
    view.DataChanged()
    
def fix():
    global view
    view.SetXAxis((-1000.,1000.))
    view.SetYAxis((0.,4000.))
    view.DataChanged()
                                        
def add():
    global view,arr1,arr2,arr3
    view.SetY2Axis((0,1))
    view.SetSource((Graph(arr1,pen=Pen((0,0,255),3,"solid")),Graph(arr2,pen=Pen((0,255,0),3,"solid")),Graph(arr3,xdata=x,yscale=1,pen=Pen((255,0,0),3,"dotted"))))

if "qt" in sys.modules.keys():
    root = qt.QApplication(sys.argv)      
    view = GraphView(None)
else:
    root = Tkinter.Tk()
    view = GraphView(root)

arr1 = Numeric.zeros ((500,))
arr2 = Numeric.zeros ((500,))
arr3 = Numeric.zeros ((500,),'float')
for i in range(500):
    arr1[i]= i
    arr2[i]= i*(1.1)
    arr3[i]= float(i)/500.
x=Numeric.arrayrange(500)
x=(x-250.)*2.

view.SetSource((Graph(arr1,pen=Pen((0,0,255),3,"solid")),Graph(arr2,pen=Pen((0,255,0),3,"solid"))))

view.AddMenuSeparator()
view.AddMenuPopupItem("Change",cmd)
view.AddMenuPopupItem("Fix Axis",fix)
view.AddMenuPopupItem("Add Y2 Function",add)


if "qt" in sys.modules.keys():
    view.resize(500,500)
    view.Show()    
    root.setMainWidget(view)
    root.exec_loop()
else:
    view.Show()
    root.mainloop()

